if wscript.arguments.count = 0 then

	wscript.echo "Could not run."
	wscript.echo "Specify the netbios name of an Exchange server on the command line"

	wscript.quit(-1)

end if

servername = wscript.arguments(0)
debugon=false

' setup output file
if wscript.arguments.count = 2 then
	filename = wscript.arguments(1)
else
	filename = "checker.log" ' default name/location
end if

Set objFSO = CreateObject("Scripting.FileSystemObject")
set fscon = objfso.CreateTextFile(filename)


set conn = createobject("ADODB.Connection")
set com = createobject("ADODB.Command")
Set iAdRootDSE = GetObject("LDAP://RootDSE")
strNameingContext = iAdRootDSE.Get("configurationNamingContext")
strDefaultNamingContext = iAdRootDSE.Get("defaultNamingContext")
Conn.Provider = "ADsDSOObject"
Conn.Open "ADs Provider"


svcQuery = "<LDAP://" & strNameingContext & ">;(&(objectCategory=msExchExchangeServer)(cn=" & Servername & "));cn,name,legacyExchangeDN;subtree"
Com.ActiveConnection = Conn
Com.CommandText = svcQuery
Set Rs = Com.Execute

' Write out header info to file
fscon.writeline "Starting to process mailboxes on " & servername
fscon.writeline "Processing started at " & date() & " " & time()

while not rs.eof 
	GALQueryFilter = "(&(&(&(& (mailnickname=*)(!msExchHideFromAddressLists=TRUE)(|(&(objectCategory=person)(objectClass=user)(msExchHomeServerName=" & rs.fields("legacyExchangeDN") & ")) )))))"
	strQuery = "<LDAP://" & strDefaultNamingContext & ">;" & GALQueryFilter & ";distinguishedName,mail,mailnickname;subtree"
	com.Properties("Page Size") = 100
	Com.CommandText = strQuery
	Set Rs1 = Com.Execute

	while not Rs1.eof

		' for debugging purposes we look at tcowper

		if debugon=true then
			if UCase(rs1.fields("mailnickname")) = "MARKB" then
				fscon.Writeline "Checking Permission on: " & rs1.fields("mailnickname") 
				wscript.echo "Checking Permission on: " & rs1.fields("mailnickname") 
				call checkperms(servername,rs1.fields("mailnickname"))
			end if
			rs1.movenext
		else
			fscon.Writeline "Checking Permission on: " & rs1.fields("mailnickname") 
			wscript.echo "Checking Permission on: " & rs1.fields("mailnickname") 
			call checkperms(servername,rs1.fields("mailnickname"))
			rs1.movenext
		end if
		
	wend	
	rs.movenext
wend
rs.close
set conn = nothing

set com = nothing

' Closing file
fscon.writeline "Processing finished at " & date() & " " & time()
fscon.close

function checkperms(servername, mailboxname)
	
	Set objSession = CreateObject("MAPI.Session")
	objSession.Logon "","",false,true,true,true,servername & vbLF & mailboxname
		
	Set CdoInfoStore = objSession.GetInfoStore
	Set CdoFolderRoot = CdoInfoStore.RootFolder
	Set ACLObj = CreateObject("MSExchange.aclobject")

	' Start at the very top of the information store
	set oFolders = cdoFolderRoot.folders
	if ofolders.count > 0 then
		for each ofolder in oFolders
			if debugon = true then 
				wscript.echo ""
				wscript.echo "Processing : " & oFolder.Name
			end if
			t = checkfolder(ofolder, objSession, ACLObj)
		next
	end if

        ' Do the top of the information store, ie root folder last
	if debugon = true then 
		wscript.echo  ""
		wscript.echo cdoFolderRoot.Name	
	end if
        ACLObj.CDOItem = cdoFolderRoot
	Set FolderACEs = ACLObj.ACEs
               
        ' Loop through all of the ACEs for the folder and display them
	for each fldace in FolderACEs
		acename = GetACLEntryName(fldace.ID, objSession)
		acerule = DispACERules(fldAce)
		if debugon = true then 
			wscript.echo acename & " : " & acerule
		end if
		if acerule <> "None" then
			fscon.Writeline cdofolderRoot.name & " -> " & acename & " : " & acerule
		end if
	next
	fscon.writeline ""
	
       ' Clean up objects
       Set FolderACEs = Nothing
       Set CDOFolder = Nothing
       Set ACLObj = Nothing
    
       ' Logoff the CDO (1.2, 1.21) session
       objSession.Logoff
       Set objSession = Nothing
   
end function

function checkfolder(folder, objsession, ACLObj)
	if folder.folders.count > 0 then
		if debugon = true then
			wscript.echo "Found : " & folder.folders.count & " subfolders of " & folder.Name
		end if
		for each xfolder in folder.folders
			t = checkfolder(xfolder, objSession, ACLObj)
		next
	end if

        ACLObj.CDOItem = Folder
        Set FolderACEs = ACLObj.ACEs
	if debugon = true then 
		wscript.echo ">>Doing folder " & folder.name
	end if
                
        ' Loop through all of the ACEs for the folder and display them
	for each fldace in FolderACEs
		acename = GetACLEntryName(fldace.ID, objSession)
		acerule = DispACERules(fldAce)
		if debugon = true then
			wscript.echo acename & " : " & acerule 
		end if
		if acerule <> "None" then
			fscon.Writeline folder.name & " -> " & acename & " : " & acerule 
		end if
	next
end function

Function GetACLEntryName(ACLEntryID, SubSession)
    ' This function finds the user that is listed as an ACE on the folder.
    ' It takes the ID that it is passed and uses the SubSession.GetAddressEntry method to find the name
    
    select case ACLEntryID
		case "ID_ACL_DEFAULT"
			tmp = "Default"
		case "ID_ACL_ANONYMOUS"
			tmp = "Anonymous"
		case else
			set oName = SubSession.GetAddressEntry(ACLEntryID)
			tmp = oName.Name
			set oName = Nothing
			set oAddrBook = Nothing
    end select
 
    GetACLEntryName = tmp
    
End Function

Function DispACERules(DisptmpACE)
    ' This function checks the roles of the ACE that is passed to it and returns the role
    
    Select Case DisptmpACE.Rights
    
        Case ROLE_NONE, 0  ' Checking in case the role has not been set on that entry.
                DispACERules = "None"
        Case ROLE_AUTHOR
                DispACERules = "Author"
        Case ROLE_CONTRIBUTOR
                DispACERules = "Contributor"
        Case 1147  ' Check value since ROLE_EDITOR is incorrect
                DispACERules = "Editor"
        Case ROLE_NONEDITING_AUTHOR
                DispACERules = "Nonediting Author"
        Case 2043  ' Check value since ROLE_OWNER is incorrect
                DispACERules = "Owner"
        Case ROLE_PUBLISH_AUTHOR
                DispACERules = "Publishing Author"
        Case 1275  ' Check value since ROLE_PUBLISH_EDITOR is incorrect
                DispACERules = "Publishing Editor"
        Case ROLE_REVIEWER
                DispACERules = "Reviewer"
        Case Else
        ' This will grab all other custom permissions on the folder
                DispACERules = "Custom"
    End Select

End Function




